// Servo four-button control Program
// Control of a Servo Motor Claw
// Most Servo angle range from 0 to 180 which is a 180 degree limit 
// Some - our WP are limited to 45 to 135 which is a 90 degree limit 
////////////////////

#include <Servo.h>

Servo myservo1;  // create servo object to control a servo 
Servo myservo2;
int pos1 = 45;  // variable to store the servo position 
int pos2 = 45;

int button1 = 3;   //button variables
int button2 = 4;
int button3 = 5;
int button4 = 6;

int delaytime = 15;

int buttonState1 = 0;  // variable for reading the pushbutton status
int buttonState2 = 0;
int buttonState3 = 0;
int buttonState4 = 0;

// variables will change:
void setup() {
  
  pinMode(button1, INPUT);     
  pinMode(button2, INPUT);
  pinMode(button3, INPUT);
  pinMode(button4, INPUT);
  
  myservo1.attach(9);  // attaches the servo on pin 9 to the servo object. This is the claw
  myservo2.attach(10); // attaches the servo on pin 10 to the servo object. This is the wrist 
}

void loop(){
  
  buttonState1 = digitalRead(button1);
  buttonState2 = digitalRead(button2);
  buttonState3 = digitalRead(button3);
  buttonState4 = digitalRead(button4);
  
  if (buttonState1 == HIGH) {
    forward1();    
  } 

  if (buttonState2 == HIGH) {
    backward1();
  } 

  if (buttonState3 == HIGH) {
    forward2();
  } 

  if (buttonState4 == HIGH){
    backward2();
  } 
}
  

/////////////////////SERVO 1////////////////////////////////////////////
void forward1 ()
{
  if(pos1 < 134){
  pos1 += 1;
  myservo1.write(pos1);
  delay(delaytime);
  }
}
void backward1 ()
{
  if(pos1 > 46){
  pos1 -= 1;
  myservo1.write(pos1);
  delay(delaytime);
  }
}

//////////////////////////SERVO 2///////////////////////////
void forward2 ()
{
  if(pos2 < 134){
  pos2 += 1;
  myservo2.write(pos2);
  delay(delaytime);
  }
}
void backward2 ()
{
  if(pos2 > 46){
  pos2 -= 1;
  myservo2.write(pos2);
  delay(delaytime);
  }
}

