// Servo Keyboard control Program
// Control of a Servo Motor Arm
// Most Servo angle range from 0 to 180 which is a 180 degree limit 
// Some - our WP are limited to 45 to 135 which is a 90 degree limit 
////////////////////

#include <Servo.h>  // implements the servo library

Servo myservo1;  // create servo object to control a servo 
                 // a maximum of eight servo objects can be created 
Servo myservo2;
Servo myservo3;
Servo myservo4;
  
int pos1 = 90;  // variable to store the servo position 
int pos2 = 90;
int pos3 = 90;
int pos4 = 90;
int led = 13;  // variable to identify LED is on pin 13
int incomingByte;  // variable for input via keyboard serial

// This section or function of the program has steps that are only done once at the start 
void setup() 
{
  Serial.begin(9600);       // allows us to listen to the serial communication between the arduino this is the baud rate that is bits per sec
 
  myservo1.attach(3);       // attaches the servo on pin 3, 4, 5, 6 to the servo object
  myservo2.attach(4);
  myservo3.attach(5);
  myservo4.attach(6);
  pinMode(led,OUTPUT);      // sets the LED pin as an output or result 
}
// This section or function of the program has steps that are only done once at the start 


// This section or function of the program has steps that are done repeatedly as the program is running 
void loop() {
  if (Serial.available() > 0) {
    incomingByte = Serial.read();
    
    if(incomingByte == 'i') //servo 1
    ii(); //move clockwise function is requested
    if(incomingByte == 'j') 
    jj(); //move counterclockwise function is requested
    
    if(incomingByte == 'k') //servo 2
    kk(); //move clockwise
    if(incomingByte == 'm') 
    mm(); // move counter clockwise
   
    if(incomingByte == 'w')// servo 3
    ww(); //move clockwise
    if(incomingByte == 's')
    ss(); //move counter clockwise
    
    if(incomingByte == 'a')// servo 4
    aa(); //move clockwise
    if(incomingByte == 'd')
    dd(); //move counter clockwise
    
    if(incomingByte == 'l')//LED 13 tester
    ll(); //turn on led 13
    if(incomingByte == 'p')
    pp(); //turn off led 13
    
  }
  
   
  Serial.flush();      //  Dumps garbled input
  
}

// This section or function of the program that has steps that are done repeatedly as the program is running 

////////////////////LED 13 TESTER Function///////////////////////////////////////////
void ll (){
digitalWrite(led, HIGH);         // turn the LED on (HIGH is the voltage level)
 Serial.println("Led is On");   //  Display a note that LED is on
  delay(1000);                  // wait for a second
}
void pp (){
digitalWrite(led, LOW);          // turn the LED off by making the voltage LOW
 Serial.println("Led is Off");    //  Display a note that LED is off
  delay(1000);                  // wait for a second
}


/////////////////////SERVO 1////////////////////////////////////////////

void ii ()
{
  if(pos1 < 135){
  pos1 += 2;
  myservo1.write(pos1);
  Serial.println("Base Arm Opening");   //  Display a note that Base Arm Opening
  delay(15);
  }
if(pos1 == 135){
   Serial.println("Base Arm Full Open");   //  Display a note that Base Arm Full Open
  delay(15);
  }   
 if(pos1 > 135){
   pos1 = 135;
   myservo1.write(pos1);
    Serial.println("Base Arm Full Open");   //  Display a note that Base Arm Full Open
   delay(15);
 } 
}
void jj ()
{
  if(pos1 > 45){
  pos1 -= 2;
  myservo1.write(pos1);
   Serial.println("Base Arm Closing");   //  Display a note that Base Arm Closing
  delay(15);
  }
if(pos1 == 45){
   Serial.println("Base Arm Full Close");   
  delay(15);
  }   
 if(pos1 < 45){
 pos1 = 45;
 myservo1.write(pos1);
  Serial.println("Base Arm Full Close");  
 delay(15);
 } 
}

//////////////////////////SERVO 2///////////////////////////
void kk ()
{
 if(pos2 < 135){
  pos2 += 2;
  myservo2.write(pos2);
  Serial.println("Fore Arm Opening");   //  Display a note that Fore Arm Opening
  delay(15);
  }
if(pos2 == 135){
   Serial.println("Fore Arm Full Open");   //  Display a note that Fore Arm Full Open
  delay(15);
  }   
 if(pos2 > 135){
   pos2 = 135;
   myservo2.write(pos2);
    Serial.println("Fore Arm Full Open");   //  Display a note that Fore Arm Full Open
   delay(15);
 } 
 
}
void mm ()
{
  if(pos2 > 45){
  pos2 -= 2;
  myservo2.write(pos2);
   Serial.println("Fore Arm Closing");   //  Display a note that Fore Arm Closing
  delay(15);
  }
if(pos2 == 45){
   Serial.println("Fore Arm Full Close");   
  delay(15);
  }   
 if(pos2 < 45){
 pos2 = 45;
 myservo2.write(pos2);
  Serial.println("Fore Arm Full Close");  
 delay(15);
 } 

 
}

//////////SERVO 3//////////////////////////////////////////////////
void ww ()
{
 if(pos3 < 135){
  pos3 += 2;
  myservo3.write(pos3);
  Serial.println("Wrist Opening");   //  Display a note that Wrist Opening
  delay(15);
  }
if(pos3 == 135){
   Serial.println("Wrist Full Open");   //  Display a note that Wrist Full Open
  delay(15);
  }   
 if(pos3 > 135){
   pos3 = 135;
   myservo3.write(pos3);
    Serial.println("Wrist Full Open");   //  Display a note that Wrist Full Open
   delay(15);
 } 
 
}
void ss ()
{
  if(pos3 > 45){
  pos3 -= 2;
  myservo3.write(pos3);
   Serial.println("Wrist Closing");   //  Display a note that Wrist Closing
  delay(15);
  }
if(pos3 == 45){
   Serial.println("Wrist Full Close");   
  delay(15);
  }   
 if(pos3 < 45){
 pos3 = 45;
 myservo3.write(pos3);
  Serial.println("Wrist Full Close");  
 delay(15);
 } 

}
//////////////SERVO 4///////////////////////////////////////////////////
void aa ()
{
 if(pos4 < 135){
  pos4 += 2;
  myservo4.write(pos4);
  Serial.println("Claw Opening");   //  Display a note that Claw Opening
  delay(15);
  }
if(pos4 == 135){
   Serial.println("Claw Full Open");   //  Display a note that Claw Full Open
  delay(15);
  }   
 if(pos4 > 135){
   pos4 = 135;
   myservo4.write(pos4);
    Serial.println("Claw Full Open");   //  Display a note that Claw Full Open
   delay(15);
 } 
 
}
void dd ()
{
  if(pos4 > 45){
  pos4 -= 2;
  myservo4.write(pos4);
   Serial.println("Claw Closing");   //  Display a note that Claw Closing
  delay(15);
  }
if(pos4 == 45){
   Serial.println("Claw Full Close");   
  delay(15);
  }   
 if(pos4 < 45){
 pos4 = 45;
 myservo4.write(pos4);
  Serial.println("Claw Full Close");  
 delay(15);
 } 

}
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
